using RealEstateTransactions.Reports;
using RealEstateTransactions.Repositories;
using Unity;

namespace RealEstateTransactions.Forms
{
    public partial class FormPriceReport : Form
    {
        private readonly IUnityContainer _container;

        public FormPriceReport(IUnityContainer container, IApartmentRepository repository)
        {
            InitializeComponent();
            _container = container ?? throw new ArgumentNullException(nameof(container));
            comboBoxApartmentId.DataSource = repository.ReadApartments();
            comboBoxApartmentId.DisplayMember = "Id";
            comboBoxApartmentId.ValueMember = "Id";
        }

        private void ButtonSelectFilePath_Click(object sender, EventArgs e)
        {
            var sfd = new SaveFileDialog()
            {
                Filter = "Excel Files | *.xlsx"
            };

            if (sfd.ShowDialog() != DialogResult.OK) return;

            textBoxFilePath.Text = sfd.FileName;
        }

        private void ButtonMakeReport_Click(object sender, EventArgs e)
        {
            try
            {
                if (string.IsNullOrWhiteSpace(textBoxFilePath.Text))
                    throw new Exception("Отсутствует имя файла для отчета");
                
                if (comboBoxApartmentId.SelectedIndex < 0)
                    throw new Exception("Не выбрана квартира");
                
                if (dateTimePickerDateEnd.Value <= dateTimePickerDateStart.Value)
                    throw new Exception("Дата начала должна быть раньше даты окончания");
                
                if (_container.Resolve<TableReport>().CreateTable(textBoxFilePath.Text,
                (int)comboBoxApartmentId.SelectedValue!,
                dateTimePickerDateStart.Value, dateTimePickerDateEnd.Value))
                {
                    MessageBox.Show("Документ сформирован", "Формирование документа",
                    MessageBoxButtons.OK, MessageBoxIcon.Information);
                }
                else
                {
                    MessageBox.Show("Возникли ошибки при формировании документа.Подробности в логах",
                    "Формирование документа", MessageBoxButtons.OK, MessageBoxIcon.Information);
                }
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message, "Ошибка при создании очета",
                MessageBoxButtons.OK, MessageBoxIcon.Error);
            }
        }
    }
}